diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/framework/remux/remux.c oss-v4.1test0-070624-src-gpl/kernel/framework/remux/remux.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/framework/remux/remux.c	Sun Jun 24 18:09:42 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/framework/remux/remux.c	Tue Jun 26 22:19:45 2007
@@ -103,7 +103,7 @@
 static int
 remux_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void remux_trigger (int dev, int state);
@@ -125,7 +125,7 @@
   if (mode & OPEN_READ)
     {
       cmn_err (CE_WARN, "Audio device %d cannot do recording\n", dev);
-      /* return -ENOTSUP; */
+      /* return RETERR(ENOTSUP); */
     }
 
   MUTEX_ENTER_IRQDISABLE (devc->mutex, flags);
@@ -134,7 +134,7 @@
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
 
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
   devc->open_mode = mode;
   MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
@@ -303,7 +303,7 @@
 static int
 remux_prepare_for_input (int dev, int bsize, int bcount)
 {
-  return -EIO;
+  return RETERR(EIO);
 }
 
 static int
@@ -336,7 +336,7 @@
 	{
 	  cmn_err (CE_NOTE, "remux: Bad sample format %x\n", tmp);
 	  MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-	  return -EIO;
+	  return RETERR(EIO);
 	}
 
       tmp = pdev->d->set_channels (pd, 2);
@@ -344,7 +344,7 @@
 	{
 	  cmn_err (CE_NOTE, "remux: Bad number of channels %d\n", tmp);
 	  MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-	  return -EIO;
+	  return RETERR(EIO);
 	}
 
       tmp = pdev->d->set_rate (pd, devc->speed);
@@ -352,7 +352,7 @@
 	{
 	  cmn_err (CE_NOTE, "remux: Bad sample rate %d\n", tmp);
 	  MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-	  return -EIO;
+	  return RETERR(EIO);
 	}
 
       if (pdev->min_block > 0 && bsize < pdev->min_block)
@@ -385,7 +385,7 @@
       if (dmap->dmabuf == NULL)
 	{
 	  cmn_err (CE_WARN, "dmabuf==NULL\n");
-	  return -ENOMEM;
+	  return RETERR(ENOMEM);
 	}
 
       memset (dmap->dmabuf, 0, dmap->buffsize);
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/framework/sndstat/sndstat.c oss-v4.1test0-070624-src-gpl/kernel/framework/sndstat/sndstat.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/framework/sndstat/sndstat.c	Sun Jun 24 18:09:42 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/framework/sndstat/sndstat.c	Tue Jun 26 22:19:45 2007
@@ -582,7 +582,7 @@
     return 0;
 
   if (uiomove (&sndstat_buf[sndstat_ptr], l, UIO_READ, buf) != 0)
-    return -EFAULT;
+    return RETERR(EFAULT);
   sndstat_ptr += l;
 
   return l;
@@ -594,13 +594,13 @@
 {
   /* TODO: Concurrency control */
   if (sndstat_busy)
-    return -EBUSY;
+    return RETERR(EBUSY);
   sndstat_busy = 1;
 
   if ((sndstat_buf = KERNEL_MALLOC (4096)) == NULL)
     {
       sndstat_busy = 0;
-      return -ENOMEM;
+      return RETERR(ENOMEM);
     }
 
   sndstat_len = 0;
@@ -639,7 +639,7 @@
   oss_detach_enabled = 1;
   return count;
 #else
-  return -EIO;
+  return RETERR(EIO);
 #endif
 }
 
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/framework/uart401/uart401.c oss-v4.1test0-070624-src-gpl/kernel/framework/uart401/uart401.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/framework/uart401/uart401.c	Sun Jun 24 18:09:42 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/framework/uart401/uart401.c	Tue Jun 26 22:19:45 2007
@@ -124,7 +124,7 @@
 
   if (devc->opened)
     {
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   while (input_avail (devc))
@@ -189,7 +189,7 @@
 static int
 uart401_ioctl (int dev, unsigned cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static midi_driver_t uart401_driver = {
diff -urN oss-v4.1test0-070624-src-gpl.org/lib/libOSSlib/compile.sh oss-v4.1test0-070624-src-gpl/lib/libOSSlib/compile.sh
--- oss-v4.1test0-070624-src-gpl.org/lib/libOSSlib/compile.sh	Thu Jun 29 00:08:43 2006
+++ oss-v4.1test0-070624-src-gpl/lib/libOSSlib/compile.sh	Tue Jun 26 22:19:45 2007
@@ -66,6 +66,10 @@
 	$MAKE libOSSlib.a CFLAGS=""
 	;;
 
+"BeOS"|"Haiku")
+	$MAKE libOSSlib.a CFLAGS=""
+	;;
+
 *)
       echo Can\'t recognize your operating system '('`uname`')'.
       echo;echo
diff -urN oss-v4.1test0-070624-src-gpl.org/lib/libsalsa/main.c oss-v4.1test0-070624-src-gpl/lib/libsalsa/main.c
--- oss-v4.1test0-070624-src-gpl.org/lib/libsalsa/main.c	Tue Jun 12 14:24:22 2007
+++ oss-v4.1test0-070624-src-gpl/lib/libsalsa/main.c	Tue Jun 26 22:19:46 2007
@@ -43,13 +43,13 @@
   if (mixer_fd == -1)
     {
       if ((mixer_fd = open ("/dev/mixer", O_RDONLY, 0)) == -1)
-	return -errno;
+	return RETERR(errno);
     }
 
   if (ioctl (mixer_fd, SNDCTL_SYSINFO, &sysinfo) == -1)
     {
       perror ("SNDCTL_SYSINFO");
-      return -errno;
+      return RETERR(errno);
     }
 
   return 0;
@@ -214,7 +214,7 @@
 {
   ALIB_INIT ();
   if (!alib_appcheck ())
-    return -ENODEV;
+    return RETERR(ENODEV);
 
   if (*rcard == -1)
     *rcard = 0;
@@ -242,7 +242,7 @@
 snd_card_get_index (const char *string)
 {
   dbg_printf ("snd_card_get_index(%s)\n", string);
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 /**
@@ -281,7 +281,7 @@
 
   ALIB_INIT ();
   if (!alib_appcheck ())
-    return -ENODEV;
+    return RETERR(ENODEV);
 
   *ctlp = NULL;
 
@@ -290,18 +290,18 @@
   else
     {
       if (name[0] != 'h' && name[1] != 'w' && name[2] != ':')
-	return -ENOENT;
+	return RETERR(ENOENT);
 
       if (sscanf (name + 3, "%d", &num) != 1)
-	return -ENOENT;
+	return RETERR(ENOENT);
     }
 
   if (num < 0 || num >= sysinfo.numcards)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
 
   if ((ctl = malloc (sizeof (*ctl))) == NULL)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
 
   memset (ctl, 0, sizeof (*ctl));
   ctl->info.card = num;
@@ -309,7 +309,7 @@
     {
       perror ("SNDCTL_CARDINFO");
       fprintf (stderr, "Mixer fd was %d\n", mixer_fd);
-      return -errno;
+      return RETERR(errno);
     }
 
   *ctlp = ctl;
@@ -371,7 +371,7 @@
 
   ci.card = card;
   if (ioctl (mixer_fd, SNDCTL_CARDINFO, &ci) == -1)
-    return -errno;
+    return RETERR(errno);
 
   *name = strdup (ci.longname);
   return 0;
@@ -407,7 +407,7 @@
 
       ctl->ainfo.dev = *device;
       if (ioctl (mixer_fd, SNDCTL_AUDIOINFO, &ctl->ainfo) < 0)
-	return -errno;
+	return RETERR(errno);
 
       if (ctl->ainfo.card_number == ctl->info.card)
 	{
diff -urN oss-v4.1test0-070624-src-gpl.org/lib/libsalsa/mix.c oss-v4.1test0-070624-src-gpl/lib/libsalsa/mix.c
--- oss-v4.1test0-070624-src-gpl.org/lib/libsalsa/mix.c	Tue Jun 12 14:24:22 2007
+++ oss-v4.1test0-070624-src-gpl/lib/libsalsa/mix.c	Tue Jun 26 22:19:47 2007
@@ -73,10 +73,10 @@
 
   ALIB_INIT ();
   if (!alib_appcheck ())
-    return -ENODEV;
+    return RETERR(ENODEV);
 
   if ((mixer = malloc (sizeof (*mixer))) == NULL)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
 
   memset (mixer, 0, sizeof (*mixer));
   *mixerp = mixer;
@@ -104,19 +104,19 @@
   else if (name[0] == 'h' && name[1] == 'w' && name[2] == ':')
     {
       if (sscanf (name + 3, "%d", &dev) != 1)
-	return -ENOENT;
+	return RETERR(ENOENT);
 
       if (dev < 0 || dev >= sysinfo.nummixers)
-	return -ENXIO;
+	return RETERR(ENXIO);
     }
   else
-    return -ENOENT;
+    return RETERR(ENOENT);
 
   mixer->mixdev = dev;
 
   mixer->info.dev = dev;
   if (ioctl (mixer_fd, SNDCTL_MIXERINFO, &mixer->info) == -1)
-    return -errno;
+    return RETERR(errno);
 
   mixer->nrext = mixer->info.nrext;
 
@@ -166,7 +166,7 @@
     return 0;
 
   if ((class = malloc (sizeof (*class))) == NULL)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
 
   memset (class, 0, sizeof (*class));
   *classp = class;
@@ -273,7 +273,7 @@
   rec.value = vol | (vol << 8);
 
   if (ioctl (mixer_fd, SNDCTL_MIX_WRITE, &rec) == -1)
-    return -errno;
+    return RETERR(errno);
 
   return 0;
 }
@@ -363,7 +363,7 @@
   rec.timestamp = elem->ext.timestamp;
 
   if (ioctl (mixer_fd, SNDCTL_MIX_READ, &rec) == -1)
-    return -errno;
+    return RETERR(errno);
 
   left = rec.value & 0xff;
   right = (rec.value >> 8) & 0xff;
@@ -513,7 +513,7 @@
     free (mixer->elems);
 
   if ((elems = malloc (sizeof (*elems) * mixer->nrext)) == NULL)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
 
   memset (elems, 0, sizeof (*elems) * mixer->nrext);
 
@@ -660,7 +660,7 @@
   rec.timestamp = elem->ext.timestamp;
 
   if (ioctl (mixer_fd, SNDCTL_MIX_READ, &rec) == -1)
-    return -errno;
+    return RETERR(errno);
 
   *value = !!rec.value;
   return 0;
@@ -782,7 +782,7 @@
   rec.value = !!value;
 
   if (ioctl (mixer_fd, SNDCTL_MIX_WRITE, &rec) == -1)
-    return -errno;
+    return RETERR(errno);
 
   return 0;
 }
diff -urN oss-v4.1test0-070624-src-gpl.org/lib/libsalsa/output.c oss-v4.1test0-070624-src-gpl/lib/libsalsa/output.c
--- oss-v4.1test0-070624-src-gpl.org/lib/libsalsa/output.c	Tue Jun 12 14:24:22 2007
+++ oss-v4.1test0-070624-src-gpl/lib/libsalsa/output.c	Tue Jun 26 22:19:47 2007
@@ -208,12 +208,12 @@
   assert (outputp && fp);
   stdio = calloc (1, sizeof (*stdio));
   if (!stdio)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
   output = calloc (1, sizeof (*output));
   if (!output)
     {
       free (stdio);
-      return -ENOMEM;
+      return RETERR(ENOMEM);
     }
   stdio->fp = fp;
   stdio->close = _close;
@@ -241,7 +241,7 @@
   if (!fp)
     {
       //SYSERR("fopen");
-      return -errno;
+      return RETERR(errno);
     }
   err = snd_output_stdio_attach (outputp, fp, 1);
   if (err < 0)
@@ -285,7 +285,7 @@
     alloc *= 2;
   buf = realloc (buffer->buf, alloc);
   if (!buf)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
   buffer->buf = buf;
   buffer->alloc = alloc;
   return buffer->alloc - buffer->size;
@@ -393,12 +393,12 @@
   assert (outputp);
   buffer = calloc (1, sizeof (*buffer));
   if (!buffer)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
   output = calloc (1, sizeof (*output));
   if (!output)
     {
       free (buffer);
-      return -ENOMEM;
+      return RETERR(ENOMEM);
     }
   buffer->buf = NULL;
   buffer->alloc = 0;
diff -urN oss-v4.1test0-070624-src-gpl.org/lib/libsalsa/pcm.c oss-v4.1test0-070624-src-gpl/lib/libsalsa/pcm.c
--- oss-v4.1test0-070624-src-gpl.org/lib/libsalsa/pcm.c	Tue Jun 12 14:24:22 2007
+++ oss-v4.1test0-070624-src-gpl/lib/libsalsa/pcm.c	Tue Jun 26 22:19:47 2007
@@ -240,7 +240,7 @@
   ALIB_INIT ();
 
   if (!alib_appcheck ())
-    return -ENODEV;
+    return RETERR(ENODEV);
 
   *pcmp = NULL;
 
@@ -257,7 +257,7 @@
 	{
 #if 0
 	  fprintf (stderr, "OSS asound - Bad PCM device '%s'\n", name);
-	  return -ENOENT;
+	  return RETERR(ENOENT);
 #else
 	  strcpy (dspname, "/dev/dsp");
 #endif
@@ -267,7 +267,7 @@
     }
 
   if ((pcm = malloc (sizeof (*pcm))) == NULL)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
 
   switch (stream)
     {
@@ -279,7 +279,7 @@
       break;
     default:
       fprintf (stderr, "snd_pcm_open: Bad stream %d\n", stream);
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
   memset (pcm, 0, sizeof (*pcm));
@@ -296,7 +296,7 @@
     {
       int err = errno;
       free (pcm);
-      return -err;
+      return RETERR(err);
     }
 
   pcm->info.dev = -1;
@@ -305,7 +305,7 @@
       int err = errno;
       close (pcm->fd);
       free (pcm);
-      return -err;
+      return RETERR(err);
     }
 
   dbg_printf ("Opened %s='%s' = %d\n", name, pcm->info.name, pcm->fd);
@@ -364,7 +364,7 @@
  * \brief Stop a PCM preserving pending frames
  * \param pcm PCM handle
  * \return 0 on success otherwise a negative error code
- * \retval -ESTRPIPE a suspend event occurred
+ * \retval RETERR(ESTRPIPE) a suspend event occurred
  *
  * For playback wait for all pending frames to be played and then stop
  * the PCM.
@@ -423,22 +423,22 @@
 
   tmp = params->oss_fmt;
   if (ioctl (pcm->fd, SNDCTL_DSP_SETFMT, &tmp) == -1)
-    return -errno;
+    return RETERR(errno);
   if (tmp != params->oss_fmt)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   tmp = params->channels;
   if (ioctl (pcm->fd, SNDCTL_DSP_CHANNELS, &tmp) == -1)
-    return -errno;
+    return RETERR(errno);
   if (tmp != params->channels)
-    return -EINVAL;
+    return RETERR(EINVAL);
   pcm->channels = tmp;
 
   tmp = params->speed;
   if (ioctl (pcm->fd, SNDCTL_DSP_SPEED, &tmp) == -1)
-    return -errno;
+    return RETERR(errno);
   if (tmp != params->speed)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   tmp = params->channels * params->sample_bits;
   pcm->frame_size = params->frame_size = tmp / 8;
@@ -460,12 +460,12 @@
 
   memset (params, 0, sizeof (params));
   if (ioctl (pcm->fd, SNDCTL_DSP_CHANNELS, &params->channels) == -1)
-    return -errno;
+    return RETERR(errno);
   pcm->channels = params->channels;
   if (ioctl (pcm->fd, SNDCTL_DSP_SETFMT, &params->oss_fmt) == -1)
-    return -errno;
+    return RETERR(errno);
   if (ioctl (pcm->fd, SNDCTL_DSP_SPEED, &params->speed) == -1)
-    return -errno;
+    return RETERR(errno);
   dbg_printf ("Rate %d, channels %d, fmt %x\n", params->speed,
 	      params->channels, params->oss_fmt);
 
@@ -496,7 +496,7 @@
     return 0;
   if (access == SND_PCM_ACCESS_MMAP_INTERLEAVED)
     return 0;
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 /**
@@ -553,10 +553,10 @@
   params->channels = val;
 
   if (ioctl (pcm->fd, SNDCTL_DSP_CHANNELS, &params->channels) < 0)
-    return -errno;
+    return RETERR(errno);
 
   if (params->channels != val)
-    return -EINVAL;
+    return RETERR(EINVAL);
   pcm->channels = params->channels;
   return 0;
 }
@@ -571,7 +571,7 @@
   params->channels = *val;
 
   if (ioctl (pcm->fd, SNDCTL_DSP_CHANNELS, &params->channels) < 0)
-    return -errno;
+    return RETERR(errno);
 
   *val = params->channels;
   pcm->channels = params->channels;
@@ -589,7 +589,7 @@
 snd_pcm_hw_params_set_format (snd_pcm_t * pcm, snd_pcm_hw_params_t * params,
 			      snd_pcm_format_t format)
 {
-  int err = -EINVAL;
+  int err = RETERR(EINVAL);
   int tmp;
 
   dbg_printf2 ("snd_pcm_hw_params_set_format(%d)\n", format);
@@ -614,10 +614,10 @@
 
   tmp = params->oss_fmt;
   if (ioctl (pcm->fd, SNDCTL_DSP_SETFMT, &tmp) < 0)
-    return -errno;
+    return RETERR(errno);
 
   if (tmp != params->oss_fmt)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   return 0;
 }
@@ -654,7 +654,7 @@
   if (format == SND_PCM_FORMAT_S16_LE)
     return 0;
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 /**
@@ -725,7 +725,7 @@
 {
   dbg_printf ("snd_pcm_hw_params_set_periods_max(%x, %x)\n", val, dir);
   return 0;
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 /**
@@ -747,10 +747,10 @@
   params->speed = val;
 
   if (ioctl (pcm->fd, SNDCTL_DSP_SPEED, &params->speed) < 0)
-    return -errno;
+    return RETERR(errno);
 
   if (val != params->speed)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   return 0;
 }
@@ -794,7 +794,7 @@
   params->speed = *val;
 
   if (ioctl (pcm->fd, SNDCTL_DSP_SPEED, &params->speed) < 0)
-    return -errno;
+    return RETERR(errno);
 
   *val = params->speed;
   return 0;
@@ -824,7 +824,7 @@
   if (nonblock == 0)
     return 0;
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 /**
@@ -846,10 +846,10 @@
  * \param size frames to be written
  * \return a positive number of frames actually read otherwise a
  * negative error code
- * \retval -EBADFD PCM is not in the right state (#SND_PCM_STATE_PREPARED or #SN
+ * \retval RETERR(EBADFD) PCM is not in the right state (#SND_PCM_STATE_PREPARED or #SN
 D_PCM_STATE_RUNNING)
- * \retval -EPIPE an overrun occurred
- * \retval -ESTRPIPE a suspend event occurred (stream is suspended and waiting f
+ * \retval RETERR(EPIPE) an overrun occurred
+ * \retval RETERR(ESTRPIPE) a suspend event occurred (stream is suspended and waiting f
 or an application recovery)
  *
  * If the blocking behaviour was selected, then routine waits until
@@ -870,7 +870,7 @@
   l = size * pcm->frame_size;
 
   if ((l = read (pcm->fd, buffer, l)) == -1)
-    return -errno;
+    return RETERR(errno);
   return l / pcm->frame_size;
 }
 
@@ -926,10 +926,10 @@
  * \param size frames to be written
  * \return a positive number of frames actually written otherwise a
  * negative error code
- * \retval -EBADFD PCM is not in the right state (#SND_PCM_STATE_PREPARED or #SN
+ * \retval RETERR(EBADFD) PCM is not in the right state (#SND_PCM_STATE_PREPARED or #SN
 D_PCM_STATE_RUNNING)
- * \retval -EPIPE an underrun occurred
- * \retval -ESTRPIPE a suspend event occurred (stream is suspended and waiting f
+ * \retval RETERR(EPIPE) an underrun occurred
+ * \retval RETERR(ESTRPIPE) a suspend event occurred (stream is suspended and waiting f
 or an application recovery)
  *
  * If the blocking behaviour is selected, then routine waits until
@@ -950,7 +950,7 @@
   l = size * pcm->frame_size;
 
   if ((l = write (pcm->fd, buffer, l)) == -1)
-    return -errno;
+    return RETERR(errno);
   return l / pcm->frame_size;
 }
 
@@ -958,13 +958,13 @@
  * \brief Resume from suspend, no samples are lost
  * \param pcm PCM handle
  * \return 0 on success otherwise a negative error code
- * \retval -EAGAIN resume can't be proceed immediately (audio hardware is probab
+ * \retval RETERR(EAGAIN) resume can't be proceed immediately (audio hardware is probab
 ly still suspended)
- * \retval -ENOSYS hardware doesn't support this feature
+ * \retval RETERR(ENOSYS) hardware doesn't support this feature
  *
  * This function can be used when the stream is in the suspend state
  * to do the fine resume from this state. Not all hardware supports
- * this feature, when an -ENOSYS error is returned, use the \link ::snd_pcm_prep
+ * this feature, when an RETERR(ENOSYS) error is returned, use the \link ::snd_pcm_prep
 are() \endlink
  * function to recovery.
  */
@@ -972,7 +972,7 @@
 snd_pcm_resume (snd_pcm_t * pcm)
 {
   dbg_printf ("snd_pcm_resume()\n");
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 /**
@@ -986,7 +986,7 @@
   assert (ptr);
   *ptr = calloc (1, sizeof (snd_pcm_status_t));
   if (!*ptr)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
   return 0;
 }
 
@@ -1011,7 +1011,7 @@
 snd_pcm_status (snd_pcm_t * pcm, snd_pcm_status_t * status)
 {
   dbg_printf ("snd_pcm_status()\n");
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 /**
@@ -1022,7 +1022,7 @@
 snd_pcm_status_get_state (const snd_pcm_status_t * obj)
 {
   dbg_printf ("snd_pcm_status_get_state()\n");
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 /**
@@ -1183,7 +1183,7 @@
   assert (ptr);
   *ptr = calloc (1, sizeof (snd_pcm_info_t));
   if (!*ptr)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
   return 0;
 }
 
@@ -1322,12 +1322,12 @@
   if (pcm->stream == SND_PCM_STREAM_PLAYBACK)
     {
       if (ioctl (pcm->fd, SNDCTL_DSP_GETOSPACE, &bi) == -1)
-	return -errno;
+	return RETERR(errno);
     }
   else
     {
       if (ioctl (pcm->fd, SNDCTL_DSP_GETISPACE, &bi) == -1)
-	return -errno;
+	return RETERR(errno);
     }
 
   dbg_printf3 ("snd_pcm_avail_update(pcm=%x)=%d\n", pcm,
@@ -1357,7 +1357,7 @@
   int tmp;
 
   if (ioctl (pcm->fd, SNDCTL_DSP_GETODELAY, &tmp) < 0)
-    return -errno;
+    return RETERR(errno);
 
   *delayp = tmp / pcm->frame_size;
   return 0;
@@ -1416,7 +1416,7 @@
     case SNDRV_PCM_FORMAT_IMA_ADPCM:
       return 4;
     default:
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 }
 
@@ -1474,11 +1474,11 @@
       return samples;
     case SNDRV_PCM_FORMAT_IMA_ADPCM:
       if (samples & 1)
-	return -EINVAL;
+	return RETERR(EINVAL);
       return samples / 2;
     default:
       assert (0);
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 }
 
@@ -1686,7 +1686,7 @@
     generate_sine(areas, offset, frames, &phase);
     commitres = snd_pcm_mmap_commit(pcm_handle, offset, frames);
     if (commitres < 0 || commitres != frames)
-      error(commitres >= 0 ? -EPIPE : commitres);
+      error(commitres >= 0 ? RETERR(EPIPE) : commitres);
       
     size -= frames;
   }
@@ -1708,7 +1708,7 @@
   if (pcm->stream == SND_PCM_STREAM_CAPTURE)
     return snd_pcm_readi (pcm, pcm->area[0].addr, frames);
 
-  return -EFAULT;
+  return RETERR(EFAULT);
 }
 
 /**
@@ -1743,7 +1743,7 @@
 snd_pcm_pause (snd_pcm_t * pcm, int enable)
 {
   dbg_printf ("snd_pcm_pause()\n");
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 /**
@@ -1965,7 +1965,7 @@
 {
   *ptr = calloc (1, sizeof (snd_pcm_hw_params_t));
   if (!*ptr)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
   return 0;
 }
 
@@ -1986,9 +1986,9 @@
  * \param size frames to be written
  * \return a positive number of frames actually written otherwise a
  * negative error code
- * \retval -EBADFD PCM is not in the right state (#SND_PCM_STATE_PREPARED or #SND_PCM_STATE_RUNNING)
- * \retval -EPIPE an underrun occurred
- * \retval -ESTRPIPE a suspend event occurred (stream is suspended and waiting for an application recovery)
+ * \retval RETERR(EBADFD) PCM is not in the right state (#SND_PCM_STATE_PREPARED or #SND_PCM_STATE_RUNNING)
+ * \retval RETERR(EPIPE) an underrun occurred
+ * \retval RETERR(ESTRPIPE) a suspend event occurred (stream is suspended and waiting for an application recovery)
  *
  * If the blocking behaviour is selected, then routine waits until
  * all requested bytes are played or put to the playback ring buffer.
@@ -2001,7 +2001,7 @@
 {
   dbg_printf ("snd_pcm_writen()\n");
   // Not supported
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 /**
@@ -2011,9 +2011,9 @@
  * \param size frames to be written
  * \return a positive number of frames actually read otherwise a
  * negative error code
- * \retval -EBADFD PCM is not in the right state (#SND_PCM_STATE_PREPARED or #SND_PCM_STATE_RUNNING)
- * \retval -EPIPE an overrun occurred
- * \retval -ESTRPIPE a suspend event occurred (stream is suspended and waiting for an application recovery)
+ * \retval RETERR(EBADFD) PCM is not in the right state (#SND_PCM_STATE_PREPARED or #SND_PCM_STATE_RUNNING)
+ * \retval RETERR(EPIPE) an overrun occurred
+ * \retval RETERR(ESTRPIPE) a suspend event occurred (stream is suspended and waiting for an application recovery)
  *
  * If the blocking behaviour was selected, then routine waits until
  * all requested bytes are filled. The count of bytes can be less only
@@ -2026,7 +2026,7 @@
 {
   dbg_printf ("snd_pcm_readn()\n");
   // Not supported
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 /**
@@ -2123,7 +2123,7 @@
  * \param pcm PCM handle
  * \param timeout maximum time in milliseconds to wait
  * \return a positive value on success otherwise a negative error code
- *         (-EPIPE for the xrun and -ESTRPIPE for the suspended status,
+ *         (RETERR(EPIPE) for the xrun and RETERR(ESTRPIPE) for the suspended status,
  *          others for general errors)
  * \retval 0 timeout occurred
  * \retval 1 PCM stream is ready for I/O
@@ -2154,7 +2154,7 @@
   dbg_printf ("select(%d, %x, %x, NULL, %x)\n",
 	      pcm->fd + 1, readfds, writefds, w);
   if (select (pcm->fd + 1, readfds, writefds, NULL, w) == -1)
-    return -errno;
+    return RETERR(errno);
 
   return FD_ISSET (pcm->fd, &fds);
 }
@@ -2169,7 +2169,7 @@
 {
   *ptr = calloc (1, sizeof (snd_pcm_sw_params_t));
   if (!*ptr)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
   return 0;
 }
 
@@ -2188,7 +2188,7 @@
 {
   dbg_printf ("snd_pcm_hw_params_get_period_time()\n");
   // TODO
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 int INTERNAL (snd_pcm_hw_params_get_buffer_time) (const snd_pcm_hw_params_t *
@@ -2197,7 +2197,7 @@
 {
   dbg_printf ("snd_pcm_hw_params_get_buffer_time()\n");
   // What's this?
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 struct _snd_mask
@@ -2270,9 +2270,9 @@
  * \param size frames to be written
  * \return a positive number of frames actually read otherwise a
  * negative error code
- * \retval -EBADFD PCM is not in the right state (#SND_PCM_STATE_PREPARED or #SND_PCM_STATE_RUNNING)
- * \retval -EPIPE an overrun occurred
- * \retval -ESTRPIPE a suspend event occurred (stream is suspended and waiting for an application recovery)
+ * \retval RETERR(EBADFD) PCM is not in the right state (#SND_PCM_STATE_PREPARED or #SND_PCM_STATE_RUNNING)
+ * \retval RETERR(EPIPE) an overrun occurred
+ * \retval RETERR(ESTRPIPE) a suspend event occurred (stream is suspended and waiting for an application recovery)
  *
  * If the blocking behaviour was selected, then routine waits until
  * all requested bytes are filled. The count of bytes can be less only
@@ -2294,9 +2294,9 @@
  * \param size frames to be written
  * \return a positive number of frames actually read otherwise a
  * negative error code
- * \retval -EBADFD PCM is not in the right state (#SND_PCM_STATE_PREPARED or #SND_PCM_STATE_RUNNING)
- * \retval -EPIPE an overrun occurred
- * \retval -ESTRPIPE a suspend event occurred (stream is suspended and waiting for an application recovery)
+ * \retval RETERR(EBADFD) PCM is not in the right state (#SND_PCM_STATE_PREPARED or #SND_PCM_STATE_RUNNING)
+ * \retval RETERR(EPIPE) an overrun occurred
+ * \retval RETERR(ESTRPIPE) a suspend event occurred (stream is suspended and waiting for an application recovery)
  *
  * If the blocking behaviour was selected, then routine waits until
  * all requested bytes are filled. The count of bytes can be less only
@@ -2318,9 +2318,9 @@
  * \param size frames to be written
  * \return a positive number of frames actually written otherwise a
  * negative error code
- * \retval -EBADFD PCM is not in the right state (#SND_PCM_STATE_PREPARED or #SND_PCM_STATE_RUNNING)
- * \retval -EPIPE an underrun occurred
- * \retval -ESTRPIPE a suspend event occurred (stream is suspended and waiting for an application recovery)
+ * \retval RETERR(EBADFD) PCM is not in the right state (#SND_PCM_STATE_PREPARED or #SND_PCM_STATE_RUNNING)
+ * \retval RETERR(EPIPE) an underrun occurred
+ * \retval RETERR(ESTRPIPE) a suspend event occurred (stream is suspended and waiting for an application recovery)
  *
  * If the blocking behaviour is selected, then routine waits until
  * all requested bytes are played or put to the playback ring buffer.
@@ -2344,9 +2344,9 @@
  * \param size frames to be written
  * \return a positive number of frames actually written otherwise a
  * negative error code
- * \retval -EBADFD PCM is not in the right state (#SND_PCM_STATE_PREPARED or #SND_PCM_STATE_RUNNING)
- * \retval -EPIPE an underrun occurred
- * \retval -ESTRPIPE a suspend event occurred (stream is suspended and waiting for an application recovery)
+ * \retval RETERR(EBADFD) PCM is not in the right state (#SND_PCM_STATE_PREPARED or #SND_PCM_STATE_RUNNING)
+ * \retval RETERR(EPIPE) an underrun occurred
+ * \retval RETERR(ESTRPIPE) a suspend event occurred (stream is suspended and waiting for an application recovery)
  *
  * If the blocking behaviour is selected, then routine waits until
  * all requested bytes are played or put to the playback ring buffer.
@@ -2373,7 +2373,7 @@
 snd_pcm_link (snd_pcm_t * pcm1, snd_pcm_t * pcm2)
 {
   dbg_printf ("snd_pcm_link()\n");
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 /**
@@ -2731,7 +2731,7 @@
     case SNDRV_PCM_FORMAT_IMA_ADPCM:
       return 4;
     default:
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 }
 
@@ -2752,7 +2752,7 @@
 {
   dbg_printf ("snd_async_add_pcm_handler()\n");
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 void *
@@ -2868,7 +2868,7 @@
 {
   dbg_printf ("snd_pcm_areas_copy()\n");
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 /**
diff -urN oss-v4.1test0-070624-src-gpl.org/lib/libsalsa/rawmidi.c oss-v4.1test0-070624-src-gpl/lib/libsalsa/rawmidi.c
--- oss-v4.1test0-070624-src-gpl.org/lib/libsalsa/rawmidi.c	Tue Jun 12 14:24:22 2007
+++ oss-v4.1test0-070624-src-gpl/lib/libsalsa/rawmidi.c	Tue Jun 26 22:19:47 2007
@@ -38,7 +38,7 @@
   ALIB_INIT ();
 
   if (!alib_appcheck ())
-    return -ENODEV;
+    return RETERR(ENODEV);
 
   return 0;
 }
